#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;

int main(){
    ll N;cin>>N;
    vector<ll> val(N);
    for(int i=0; i<N; ++i){
        cin>>val[i];
    }
    vector<vector<ll>> g(N);
    for(int i=0; i<N-1; ++i){
        ll a,b;cin>>a>>b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    // for each bit, perform bfs on the tree
    ll res=0;
    for(ll bit=0; bit<22; ++bit){
        ll value=1ll<<bit;
        vector<bool> todo(N,1);
        for(int i=0; i<N; ++i){
            todo[i]=(value & (val[i]))!=0;
        }
        for(int i=0; i<N; ++i){
            if(todo[i]){
                ll size=1;
                queue<ll> q;
                todo[i]=0;
                q.push(i);
                while(!q.empty()){
                    ll el=q.front();q.pop();
                    for(ll n:g[el])if(todo[n]){
                        todo[n]=0;
                        q.push(n);
                        size++;
                    }
                }
                // given size of the component, we know that
                //     only paths starting end ending in it
                //     will get this value
                // res += same + distinct endpoints A and B
                res+=(size+(size*(size-1))/2)*value;
            }
        }
    }
    cout<<res<<endl;

    return 0;
}

